#ifndef CHARSMOREWIDGETS_H
#define CHARSMOREWIDGETS_H

#include <QWidget>
#include "kbbutton.h"
#include <QMap>

class QVBoxLayout;
class QHBoxLayout;
class QScrollArea;
class QFrame;
class CharsMoreWidget : public QWidget
{
    Q_OBJECT
public:
    explicit CharsMoreWidget(QWidget *parent = nullptr);
    ~CharsMoreWidget();
    void adjustGeometry(double lfWidthScale, double lfHeightScale, bool isVertical = false, bool floatStatus = false);

public Q_SLOTS:
    void onBtnClicked(QChar charId);

Q_SIGNALS:
    void clicked(int nKeyId);
    void specialBtnClicked(QString keyName);
    void normalBtnClicked(QChar charId);

private:
    void initUI();

private:
    QMap<QWidget*, QRect> m_mapBtnGeometrys;
    QMap<QWidget*, QRect> m_mapSubWidgetListRects;
    QVBoxLayout *m_vlayoutBtnList = nullptr;
    QScrollArea *m_scrollFrame = nullptr;
    QFrame *listFrame = nullptr;
};

#endif // CHARSMOREWIDGETS_H
