#ifndef CHARSWIDGET_H
#define CHARSWIDGET_H

#include <QWidget>
#include "kbbutton.h"
#include <QMap>

class CharsWidget : public QWidget
{
    Q_OBJECT
public:
    explicit CharsWidget(QWidget *parent = nullptr);
    virtual ~CharsWidget();

    void adjustGeometry(double lfWidthScale, double lfHeightScale, bool isVertical = false, bool floatStatus = false);

public Q_SLOTS:
    void onBtnClicked(QChar charId);

Q_SIGNALS:
    void clicked(int nKeyId);
    void specialBtnClicked(QString keyName);
    void normalBtnClicked(QChar c);

private:
    void initUI();

private:
    QMap<KBButton*, QRect> m_mapBtnGeometrys;

};

#endif // CHARSWIDGET_H
