#ifndef NUMBERSWIDGET_H
#define NUMBERSWIDGET_H

#include <QWidget>
#include <QMap>

class KBButton;
class QVBoxLayout;
class QScrollArea;
class QFrame;
class NumbersWidget : public QWidget
{
    Q_OBJECT
public:
    explicit NumbersWidget(QWidget *parent = nullptr);
    virtual ~NumbersWidget();

    void adjustGeometry(double lfWidthScale, double lfHeightScale, bool isVertical = false, bool floatStatus = false);

public Q_SLOTS:
    void onBtnClicked(QChar charId);

Q_SIGNALS:
    void clicked(int nKeyId);
    void specialBtnClicked(QString keyName);
    void narmalBtnClicked(QChar charId);

private:
    void initUI();

private:
    QMap<QWidget*, QRect> m_mapBtnGeometrys;
    QVBoxLayout *m_layoutBtnList = nullptr;
    QScrollArea *m_scrollFrame = nullptr;
    QFrame *listFrame = nullptr;
};

#endif // NUMBERSWIDGET_H
