#ifndef SUREWIDGET_H
#define SUREWIDGET_H

#include <QWidget>
#include <QTimer>

namespace Ui {
class Surewidget;
}

class Configuration;

class Surewidget : public QWidget
{
    Q_OBJECT

public:
    explicit Surewidget(QWidget *parent = nullptr);
    ~Surewidget();
    void setText(const QString tips);
    void setStatus(int stateType, int lockType);

private:
    Ui::Surewidget *ui;
    void on_cancelBtn_Clicked();
    void onLoadingImage();
    void updatePixmap();
    static QString getHibited_tr(int type);

Q_SIGNALS:
    void cancelButtonclicked();
    void confirmButtonclicked();

private:
    int blockStatus = 0;
    QPixmap         m_waitingPixmap;
    QTimer          *w_timer;
    Configuration   *m_configuration;
    double          curFontSize;
    double m_ptToPx = 1.0;
    int             m_stateType = 0;
};

#endif // SUREWIDGET_H
